<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.12.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>kmCommon: ReadMe</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">kmCommon
   </div>
   <div id="projectbrief">kmCommon library for AVR</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.12.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() { codefold.init(0); });
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search',true);
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('md__x_1_2_r_e_a_d_m_e.html',''); initResizable(true); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div><div class="header">
  <div class="headertitle"><div class="title">ReadMe</div></div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1>kmCommon library for AVR MCUs</h1>
<p>This repository contains the kmCommon library, a generic common file for AVR MCUs and also kmCommonDefs, a collection of useful macros for value manipulation and calculations. It also includes constants and conversion factors for time and bit manipulation.</p>
<h2>Table of Contents</h2>
<ul>
<li>Version History</li>
<li>Overview</li>
<li>Usage</li>
<li>Example Code</li>
<li>Author and License</li>
</ul>
<h2>Version History</h2>
<ul>
<li>v1.0.3 Added KMC_7_BIT_SHIFT definition (2024-11-24)</li>
<li>v1.0.2 Fix in Added KMC_7_OUT_OF_16_BIT_MASK_LO and KMC_9_BIT_SHIFT definition, fix in KMC_SIGNED_ZERO (2024-11-17)</li>
<li>v1.0.1 Fix in KMC_VAR_NAME_VALUE macro, added KMC_ARRAY_SIZE macro, doxygen fixes (2024-08-04)</li>
<li>v1.0.0 Initial (2024-05-25)</li>
</ul>
<h2>Overview</h2>
<p>The <code>kmCommon</code> library provides generic common files of <em>kmFramework</em> for AVR microcontrollers. The <code>kmCommonDefs</code> provides macros for value manipulation, such as getting the string representation of a value, finding the minimum and maximum of two values, and clamping a value within a specified range. It also includes definitions of various constants and conversion factors commonly used for bit manipulation and time conversions.</p>
<h2>Usage</h2>
<p>Getting this library and adding it to own project:</p><ul>
<li>To add this module to own project as submodule - enter the main directory of the source code and use git command</li>
</ul>
<div class="fragment"><div class="line"> bash</div>
<div class="line">git submodule add git@gitlab.com:c-mos/kmAvrLibs/kmCommon.git kmCommon</div>
</div><!-- fragment --><ul>
<li>After cloning own application from git repository use following additional git command to get correct revision of submodule: <div class="fragment"><div class="line"> bash</div>
<div class="line">git submodule update --init</div>
</div><!-- fragment --></li>
</ul>
<p>Include “kmCommon.h” in each header and source file of the project</p>
<h2>Example Code</h2>
<div class="fragment"><div class="line"><span class="preprocessor">#include &lt;stdlib.h&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;stdio.h&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;stdbool.h&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;util/delay.h&gt;</span></div>
<div class="line"> </div>
<div class="line"><span class="preprocessor">#include &quot;kmCommon/kmCommon.h&quot;</span></div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">int</span> main(<span class="keywordtype">void</span>) {</div>
<div class="line">    <span class="comment">// Example usage of macros</span></div>
<div class="line">    uint8_t a = 5</div>
<div class="line">    uint8_t b = 10</div>
<div class="line">&#x2401;uint8_t c = <a class="code hl_define" href="km_common_defs_8h.html#af4ae2bd7db4825524ef32840b10ed3ff">KMC_MIN</a>(a, b)</div>
<div class="line">&#x2401;uint8_t d = <a class="code hl_define" href="km_common_defs_8h.html#adc81a21527ba9134193dd6edc7a714a1">KMC_MAX</a>(a, b)</div>
<div class="line">&#x2401;</div>
<div class="line">    <span class="keywordflow">while</span>(<span class="keyword">true</span>) {</div>
<div class="line">    }</div>
<div class="line">}</div>
<div class="ttc" id="akm_common_defs_8h_html_adc81a21527ba9134193dd6edc7a714a1"><div class="ttname"><a href="km_common_defs_8h.html#adc81a21527ba9134193dd6edc7a714a1">KMC_MAX</a></div><div class="ttdeci">#define KMC_MAX(A, B)</div><div class="ttdoc">Macro to find the maximum of two values.</div><div class="ttdef"><b>Definition</b> kmCommonDefs.h:84</div></div>
<div class="ttc" id="akm_common_defs_8h_html_af4ae2bd7db4825524ef32840b10ed3ff"><div class="ttname"><a href="km_common_defs_8h.html#af4ae2bd7db4825524ef32840b10ed3ff">KMC_MIN</a></div><div class="ttdeci">#define KMC_MIN(A, B)</div><div class="ttdoc">Macro to find the minimum of two values.</div><div class="ttdef"><b>Definition</b> kmCommonDefs.h:75</div></div>
</div><!-- fragment --><h2>Author and License</h2>
<p>Author: Krzysztof Moskwa</p>
<p>e-mail: chris[dot]moskva[at]gmail[dot]com</p>
<p>Software License: GNU General Public License (GPL) version 3.0 or later. See <a href="https://www.gnu.org/licenses/gpl-3.0.txt">LICENSE.txt</a></p>
<p><img src="https://www.gnu.org/graphics/gplv3-or-later-sm.png" alt="GPL3 Logo" class="inline"/> </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.12.0 </li>
  </ul>
</div>
</body>
</html>
